accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView

from accounts.views import signup

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path

from projects.views import (
    ProjectDeleteView,
    ProjectListView,
    ProjectDetailView,
    ProjectCreateView,
    ProjectUpdateView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
    path("<int:pk>/edit/", ProjectUpdateView.as_view(), name="edit_project"),
    path(
        "<int:pk>/delete/>", ProjectDeleteView.as_view(), name="delete_project"
    ),
]

tasks/urls.py
from django.urls import path

from tasks.views import (
    TaskCreateView,
    TaskDetailView,
    TaskEditView,
    TaskListView,
    TaskUpdateView,
    TaskDeleteView,
)

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
    path("<int:pk>/", TaskDetailView.as_view(), name="details_task"),
    path("<int:pk>/edit/", TaskEditView.as_view(), name="edit_task"),
    path("<int:pk>/delete/", TaskDeleteView.as_view(), name="delete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
]

projects/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL
# from django.conf import settings


# Create your models here.
class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models

from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    notes = models.TextField(null=True, blank=True)
    project = models.ForeignKey(
        "projects.Project",
        related_name="tasks",
        on_delete=models.CASCADE,
    )
    assignee = models.ForeignKey(
        USER_MODEL,
        related_name="tasks",
        null=True,
        on_delete=models.SET_NULL,
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login


# Create your views here.
def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST.get("username")
            password = request.POST.get("password1")
            user = User.objects.create_user(
                username=username,
                password=password,
            )
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()
    context = {
        "form": form,
    }
    return render(request, "registration/signup.html", context)

projects/views.py
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView

from projects.models import Project


# Create your views here.
class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/new.html"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])


class ProjectUpdateView(LoginRequiredMixin, UpdateView):
    model = Project
    template_name = "projects/edit.html"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])


class ProjectDeleteView(LoginRequiredMixin, DeleteView):
    model = Project
    template_name = "projects/delete.html"
    success_url = reverse_lazy("list_projects")

tasks/views.py
from django.shortcuts import redirect
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.urls import reverse_lazy

from tasks.models import Task

# from projects.models import Project


# Create your views here.
class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/new.html"
    fields = ["name", "start_date", "due_date", "project", "assignee", "notes"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.project.id])


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    template_name = "tasks/list.html"
    fields = ["is_completed"]

    def form_valid(self, form):
        task = form.save(commit=False)
        task.save()
        return redirect("show_my_tasks")


class TaskDetailView(LoginRequiredMixin, DetailView):
    model = Task
    template_name = "tasks/detail.html"


class TaskEditView(LoginRequiredMixin, UpdateView):
    model = Task
    template_name = "tasks/edit.html"
    fields = [
        "name",
        "start_date",
        "due_date",
        "is_completed",
        "assignee",
        "notes",
    ]

    def get_success_url(self):
        return reverse_lazy("details_task", args=[self.object.id])


class TaskDeleteView(LoginRequiredMixin, DeleteView):
    model = Task
    template_name = "tasks/delete.html"

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.project.id])

projects/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lan="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    {%block title%}
    <title>Projects</title>
    {%endblock title%}
    <link
      rel="stylesheet"
      type="text/css"
      href="{% static 'css/style.css' %}"
    />
  </head>
  <body>
    <header>
      <nav class="nav">
        <ul>
          {% if user.is_authenticated %}
          <a class="nav_link" href="{% url 'list_projects' %}">All Projects</a>
          <a class="nav_link" href="{% url 'show_my_tasks' %}"
            >Items to Complete</a
          >
          <a class="nav_link" href="{% url 'logout' %}">Logout</a>
          {% else %}
          <li><a href="{% url 'login' %}">Login</a></li>
          <li><a href="{% url 'signup' %}">Signup</a></li>
          {% endif %}
        </ul>
      </nav>
    </header>
    {% block content%}{%endblock content%}
  </body>
</html>

projects/templates/projects/delete.html
{% extends 'base.html'%}{% load markdownify %}{% block content %}
<main>
  <h1>Delete Project</h1>
  <div class="delete-form">
    <form method="post">
      {% csrf_token %}
      <p>Are you sure you want to delete "{{ project }}"?</p>
      {{ form.as_p }}
      <div>
        <nav><button class="button1">Delete</button></nav>
      </div>
    </form>
  </div>
</main>
{% endblock content %}

projects/templates/projects/detail.html
{% extends 'base.html'%}{% load markdownify%} {% block content%}
<main>
  <div>
    <h1>{{project.name}}</h1>
    {{project.description|markdownify}}
    <h2>{{project.tasks.all|length}}</h2>
    <p>
      <a href="{% url 'create_task' %}">Create a new task</a>
      <a class="projectBar" href="{% url 'edit_project' project.id %}"
        >Edit Project</a
      >
      <a href="{% url 'delete_project' project.id %}">Delete Project</a>
    </p>
    {%if project.tasks.all%}
    <table>
      <thead>
        <tr>
          <th>Task</th>
          <th>Assignee</th>
          <th>Start date</th>
          <th>Due date</th>
          <th>Notes</th>
          <th>Is completed</th>
        </tr>
      </thead>
      <tbody>
        {% for task in project.tasks.all%}
        <tr>
          <td>
            <a href="{% url 'details_task' task.pk%}">{{task.name}}</a>
            <br /><br />
          </td>
          <td>{{task.assignee}}<br /><br /></td>
          <td>{{task.start_date}}<br /><br /></td>
          <td>{{task.due_date}}<br /><br /></td>
          <td>{{task.notes}}<br /><br /></td>
          <td>{% if task.is_completed%} Done {% endif %}</td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    {% else %}
    <p>This project has no tasks</p>
    {% endif %}
  </div>
</main>
{%endblock content%}

projects/templates/projects/edit.html
{% extends 'base.html'%} {% load markdownify %} {% block content %}
<main>
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <nav><button class="button1">Update</button><nav>
  </form>
</main>
{% endblock content %}

projects/templates/projects/list.html
{% extends 'base.html'%} {% block content%}
<main class="main">
  <div>
    <h1>Home Projects to Tackle</h1>
    <div>
      <p><a href="{% url 'create_project' %}">Add New Project</a></p>
    </div>
    {% if project_list%}
    <table>
      <thead>
        <tr>
          <th>Project</th>
          <th>Items to Complete</th>
        </tr>
      </thead>
      <tbody>
        {% for project in project_list%}
        <tr>
          <td>
            <a href="{% url 'show_project' project.pk%}">{{project.name}}</a>
          </td>
          <td>{{project.tasks.all|length}}</td>
          <td></td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    {% else %}
    <p>You are not assigned to any projects</p>
    {% endif%}
  </div>
</main>
{%endblock content%}

projects/templates/projects/new.html
{% extends 'base.html'%} {% block content%}
<main>
  <div>
    <h1>Create a new project</h1>
    <form method="post">
      {% csrf_token %} {{ form.as_p }}
      <br />
      <nav><button class="button1">Create</button></nav>
    </form>
  </div>
</main>
{%endblock content%}

tasks/templates/tasks/delete.html
{% extends 'base.html'%}{% load markdownify %}{% block content %}
<main>
  <h1>Delete Task</h1>
  <div class="delete-form">
    <form method="post">
      {% csrf_token %}
      <p>Are you sure you want to delete "{{ task.name }}"?</p>
      {{ form.as_p }}
      <div>
        <nav><button class="button1">Delete</button></nav>
      </div>
    </form>
  </div>
</main>
{% endblock content %}

tasks/templates/tasks/detail.html
{% extends 'base.html'%}{% load markdownify%} {% block content%}
<main>
  <h1>Task</h1>
  <nav>
    <a class="taskDetailBar" href="{% url 'edit_task' task.id %}">Edit Task</a>
    <a class="taskDetailBar" href="{% url 'delete_task' task.id %}">
      Delete Task
    </a>
    <a class="taskDetailBar" href="{% url 'show_project' task.project.id %}">
      Back to Project
    </a>
  </nav>
  <br />
  <br />
  <div>
    <table>
      <thead>
        <tr>
          <th>Task</th>
          <th>Assignee</th>
          <th>Start date</th>
          <th>Due date</th>
          <th>Notes</th>
          <th>Is completed</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>{{task.name}}<br /><br /></td>
          <td>{{task.assignee}}<br /><br /></td>
          <td>{{task.start_date}}<br /><br /></td>
          <td>{{task.due_date}}<br /><br /></td>
          <td>{{task.notes}}<br /><br /></td>
          <td>{% if task.is_completed%} Done {% endif %}</td>
        </tr>
      </tbody>
    </table>
  </div>
</main>
{% endblock content %}

tasks/templates/tasks/edit.html
{% extends 'base.html'%} {% load markdownify %} {% block content %}
<main>
  <h1>Update Task</h1>
  <form method="post">
    {% csrf_token %} {{ form.as_p }}
    <nav><button class="button1">Update</button></nav>
  </form>
</main>
{% endblock content %}

tasks/templates/tasks/list.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h1>To Do List</h1>
    {% if task_list%}
    <table>
      <thead>
        <tr>
          <th>Name</th>
          <th>Start date</th>
          <th>End date</th>
          <th>Is completed</th>
        </tr>
      </thead>
      <tbody>
        {% for task in task_list%}
        <tr>
          <td>{{ task.name }}</td>
          <td>{{ task.start_date|date:"m-d-Y" }}</td>
          <td>{{ task.due_date|date:"m-d-Y" }}</td>
          <td>
            {% if task.is_completed%} Done {% else %}
            <form method="post" action="{% url 'complete_task' task.id %}">
              {% csrf_token %}
              <input type="hidden" name="is_completed" value="True" />
              <button>Complete</button>
            </form>
            {%endif%}
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    {% else %}
    <p>You have no tasks</p>
    {% endif%}
  </div>
</main>
{% endblock content %}

tasks/templates/tasks/new.html
{% extends 'base.html'%} {% block content %}
<main>
  <div>
    <h1>Create a new task</h1>
    <form method="post">
      {% csrf_token %} {{ form.as_p }}
      <nav><button class="button1">Create</button></nav>
    </form>
  </div>
</main>
{% endblock content %}